//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkMHDFileInfo.h"
#include "bbcreaVtkPackage.h"
namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,MHDFileInfo)
BBTK_BLACK_BOX_IMPLEMENTATION(MHDFileInfo,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MHDFileInfo::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
printf("EED MHDFileInfo::Process %s \n", bbGetInputFileName().c_str() );

	std::string inputfilename;
	inputfilename=bbGetInputFileName();


	int dimX=-1,dimY=-1,dimZ=-1;
	int dim=-1;
	std::string formattype("VOID");
	float spcX=-1,spcY=-1,spcZ=-1;
	float ox=-1,oy=-1,oz=-1;
	long int headersize=0;

	char mystring[250];
	char strTmp[30];
	char strTmp2[30];
	FILE *ffIn	= fopen(inputfilename.c_str(),"r");
	if (ffIn!=NULL)
	{
		while(!feof(ffIn))
		{
    	    strcpy(mystring,"\n");
   			fgets(mystring,250,ffIn);
   	     	if (strncmp("NDims",mystring,5)==0) 			{ sscanf(mystring,"%s %s %d"		,strTmp, strTmp, &dim); 				}
        	if (strncmp("DimSize",mystring,6)==0) 			{ sscanf(mystring,"%s %s %d %d %d"	,strTmp, strTmp, &dimX, &dimY,&dimZ);	} 
			if (strncmp("ElementType",mystring,11)==0) 		{ sscanf(mystring,"%s %s %s"		,strTmp, strTmp, strTmp2); formattype=strTmp2;			}
			if (strncmp("ElementSpacing",mystring,14)==0) 	{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);	}
			if (strncmp("ElementSize",mystring,11)==0) 		{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);	}
         	if (strncmp("Offset",mystring,6)==0) 			{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &ox, &oy, &oz);		}
        	if (strncmp("HeaderSize",mystring,10)==0) 		{ sscanf(mystring,"%s %s %ld"		,strTmp, strTmp, &headersize);			}
    	} // while
   		fclose(ffIn);
	} // if

	std::vector<int> LstDimSize;
	LstDimSize.push_back(dimX);
	LstDimSize.push_back(dimY);
	LstDimSize.push_back(dimZ);

	std::vector<double> LstSpacing;
	LstSpacing.push_back((double)spcX);
	LstSpacing.push_back((double)spcY);
	LstSpacing.push_back((double)spcZ);

	std::vector<double> LstOffset;
	LstOffset.push_back((double)ox);
	LstOffset.push_back((double)oy);
	LstOffset.push_back((double)oz);

	bbSetOutputDim( dim );
	bbSetOutputDimSize( LstDimSize );
	bbSetOutputElementType( formattype );
	bbSetOutputElementSpacing( LstSpacing );
	bbSetOutputOffset( LstOffset );
	bbSetOutputHeaderSize( headersize );

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MHDFileInfo::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MHDFileInfo::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MHDFileInfo::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


