//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkScreenShot.h"
#include "bbcreaVtkPackage.h"

#include "vtkWindowToImageFilter.h"
#include "vtkPNGWriter.h"
#include "vtkWindow.h"

// #include "vtkFFMPEGWriter.h"


namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,ScreenShot)
BBTK_BLACK_BOX_IMPLEMENTATION(ScreenShot,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ScreenShot::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
      	vtkWindowToImageFilter *wif = vtkWindowToImageFilter::New();
		if (bbGetInputSize().size()==2) 
		{
			bbGetInputvtkRenderer()->GetVTKWindow()->SetSize( bbGetInputSize()[0], bbGetInputSize()[1] );
		}
      	wif->SetInput( bbGetInputvtkRenderer()->GetVTKWindow() );
//      	wif->SetMagnification( bbGetInputScale()[0] );
      	wif->SetScale( bbGetInputScale()[0], bbGetInputScale()[1] );
      	wif->SetInputBufferTypeToRGB();
      	wif->ReadFrontBufferOff();
      	wif->Update();
      	vtkPNGWriter *writer = vtkPNGWriter::New();
		writer->SetFileName( bbGetInputFileName().c_str() );

//EED 2017-01-01 Migration VTK7
#if VTK_MAJOR_VERSION <= 5
		writer->SetInput( wif->GetOutput() );
#else
		writer->SetInputData( wif->GetOutput() );
#endif


		writer->Write();	

/*
	vtkFFMPEGWriter *writer2 = vtkFFMPEGWriter::New();
	writer2->SetInput(wif->GetOutput());
	for (int i=0; i<10; i++)
	{
		// update
		writer2->Write();
	} // for 
	writer2->End;
*/
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ScreenShot::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputvtkRenderer(NULL);
   bbSetInputFileName("ScreenShot-BBTK.png");
   
   std::vector<int> scale;
   scale.push_back(1);
   scale.push_back(1);
   bbSetInputScale(scale);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ScreenShot::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ScreenShot::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


