//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkNIFTIImageReader.h"
#include "bbcreaVtkPackage.h"

#include <vtkNIFTIImageReader.h>
#include <vtkStringArray.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,NIFTIImageReader)
BBTK_BLACK_BOX_IMPLEMENTATION(NIFTIImageReader,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void NIFTIImageReader::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  

	std::vector<vtkImageData*> lstImages;

	if (bbGetInputType()==0) 
	{
		vtkNIFTIImageReader* reader=vtkNIFTIImageReader::New();
		if ( bbGetInputFileNames().size()==1)
		{
			reader->SetFileName( bbGetInputFileNames()[0].c_str() );
			reader->Update();
		} else 		{
			vtkStringArray *lstFileNames=vtkStringArray::New();
			int i,size=bbGetInputFileNames().size();
			for (i=0;i<size;i++)
			{
printf("EED Warnning, somethin is not working ????   NIFTIImageReader::Process()    %s\n ", bbGetInputFileNames()[i].c_str()  );
				lstFileNames->InsertNextValue( bbGetInputFileNames()[i].c_str() );
			} // for i
			reader->SetFileNames( lstFileNames );
			reader->Update();
		} // FileNames
		lstImages.push_back( reader->GetOutput() );
	} // Type 0

	if (bbGetInputType()==1) 
	{
		int i,size=bbGetInputFileNames().size();
		for (i=0;i<size;i++)
		{
			vtkNIFTIImageReader* reader=vtkNIFTIImageReader::New();
			reader->SetFileName( bbGetInputFileNames()[i].c_str() );
			reader->Update();
			lstImages.push_back( reader->GetOutput() );
		} // for i
	} // Type 1

	
	if (lstImages.size()>=1) { bbSetOutputOut( lstImages[0] ); } else {bbSetOutputOut( NULL ); }
	bbSetOutputOutVector( lstImages );
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void NIFTIImageReader::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputType(0);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void NIFTIImageReader::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void NIFTIImageReader::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


