//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkPointRotation.h"
#include "bbcreaVtkPackage.h"

#define _USE_MATH_DEFINES // for C
#include <math.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,PointRotation)
BBTK_BLACK_BOX_IMPLEMENTATION(PointRotation,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PointRotation::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')


printf("EED PointRotation::Process Start\n");

	if   (bbGetInputCenter().size()==3) 
	{
		std::vector<double> newpoint;
		double nx,cx = bbGetInputCenter()[0];
		double ny,cy = bbGetInputCenter()[1];
		double nz,cz = bbGetInputCenter()[2];
		double angRad = bbGetInputAngle()*M_PI/180;
		nx = bbGetInputSize() * cos( angRad ) + cx;
		ny = bbGetInputSize() * sin( angRad ) + cy;
		nz = cz;
		newpoint.push_back(nx);
		newpoint.push_back(ny);
		newpoint.push_back(nz);
    	bbSetOutputOut( newpoint );
	} // if
printf("EED PointRotation::Process End\n");
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PointRotation::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0

	std::vector<double> point;
	point.push_back(1);
	point.push_back(0);
	point.push_back(0);

	std::vector<double> center;
	center.push_back(0);
	center.push_back(0);
	center.push_back(0);

   bbSetInputSize(1);
   bbSetInputCenter(center);
   bbSetInputAngle(0);
   bbSetOutputOut(point);
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PointRotation::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PointRotation::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


