//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkPolyDataInfo.h"
#include "bbcreaVtkPackage.h"
namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,PolyDataInfo)
BBTK_BLACK_BOX_IMPLEMENTATION(PolyDataInfo,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PolyDataInfo::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  

	if ( bbGetInputIn()!=NULL)
	{
		bbSetOutputNumberOfCells( bbGetInputIn()->GetNumberOfCells() );
   		bbSetOutputNumberOfLines(  bbGetInputIn()->GetNumberOfLines() );
		bbSetOutputNumberOfPieces( bbGetInputIn()->GetNumberOfPieces() );
   		bbSetOutputNumberOfPoints(  bbGetInputIn()->GetNumberOfPoints() );
		bbSetOutputNumberOfPolys( bbGetInputIn()->GetNumberOfPolys() );
		bbSetOutputNumberOfStrips( bbGetInputIn()->GetNumberOfStrips() );
		bbSetOutputNumberOfVerts( bbGetInputIn()->GetNumberOfVerts() );

		if (bbGetInputPoints()==true)
		{
			std::vector<double> lstIds;
			std::vector<double> lstPointsX;
			std::vector<double> lstPointsY;
			std::vector<double> lstPointsZ;
			double p1[3];
			double p2[3];
			long int i,size= bbGetInputIn()->GetNumberOfPoints();
			for (i=0;i<size;i++)
			{
				if (bbGetInputIdsPoints()==true)
				{
					lstIds.push_back(i);
				} // IdsPoints
				if (bbGetInputTransform()!=NULL)
				{
					bbGetInputIn()->GetPoint(i,p1);
					bbGetInputTransform()->TransformPoint(p1,p2);
				} else {
					bbGetInputIn()->GetPoint(i,p2);
				}
				lstPointsX.push_back(p2[0]);
				lstPointsY.push_back(p2[1]);
				lstPointsZ.push_back(p2[2]);
			} // for i
			bbSetOutputLstIdsPoints(lstIds);
			bbSetOutputLstPointsX(lstPointsX);
			bbSetOutputLstPointsY(lstPointsY);
			bbSetOutputLstPointsZ(lstPointsZ);
		} // Points
	} else {
		bbSetOutputNumberOfCells(-1);
   		bbSetOutputNumberOfLines(-1);
		bbSetOutputNumberOfPieces(-1);
   		bbSetOutputNumberOfPoints(-1);
		bbSetOutputNumberOfPolys(-1);
		bbSetOutputNumberOfStrips(-1);
		bbSetOutputNumberOfVerts(-1);
	}// if

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PolyDataInfo::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputIn(NULL);
   bbSetOutputNumberOfCells(-9999);
   bbSetOutputNumberOfLines(-9999);
   bbSetOutputNumberOfPoints(-9999);
   bbSetOutputNumberOfPieces(-9999);
   bbSetOutputNumberOfPolys(-9999);
   bbSetOutputNumberOfStrips(-9999);
   bbSetOutputNumberOfVerts(-9999);
   bbSetInputIdsPoints(false);
   bbSetInputPoints(false);
   bbSetInputTransform(NULL);
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PolyDataInfo::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void PolyDataInfo::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


